﻿var oldValidatorUpdateDisplay;
var Page_HighlightValidators = new Array();
var Page_HighlightValidatorsSummaryByControl = new Array();

var ControlStyleCache = new Array();
var ControlErrorCache = new Object();

var isErrorCaught = false;

/*
 *  We keep track of error states to make sure display the correct CSS class attributes for each element.
 */

function findElementPosition_Y(obj)
{
    var curtop = 0;
    
    if(obj.offsetParent)
    {
        while(1)
        {
            curtop += obj.offsetTop;
            
            if(!obj.offsetParent)
                break;
                
            obj = obj.offsetParent;
        }
    }
    else if(obj.y)
    {
        curtop += obj.y;    
    }
    
    return curtop;
}

    
function Stack_AddError(controlID, validatorID)
{
    if(ControlErrorCache[controlID] == null)
        ControlErrorCache[controlID] = new Object();
    
    ControlErrorCache[controlID][validatorID] = "error";
}

function Stack_RemoveError(controlID, validatorID)
{
    if(ControlErrorCache[controlID] != null)
        delete ControlErrorCache[controlID][validatorID];
}

function Stack_CheckError(controlID)
{
    var validatorCount = 0;
    
    for(mystring in ControlErrorCache[controlID])
        validatorCount++;
    
    if(validatorCount > 0)
        return true;
    else
        return false;
}

function pushStyleError(validatorID, controlID, errorClassName, errorClassControlID, errorClassControlCSS)
{
    var control = document.getElementById(controlID);
   
    if(control != null)
    {
         /*
          *  Apply control error CSS
          */
    
        if(errorClassName != "")
        {
            if(ControlStyleCache[controlID] == null)
                ControlStyleCache[controlID] = control.className;
                
            control.className = errorClassName;
        }
        
        
        /*
         *  Apply css on the alternative control if applicable
         */
         
        if(errorClassControlID != "" && errorClassControlCSS != "")
        {
            var errorClassControl = document.getElementById(errorClassControlID);
            
            if(errorClassControl != null)
            {
                if(ControlStyleCache[errorClassControlID] == null)
                    ControlStyleCache[errorClassControlID] = errorClassControl.className;
                
                errorClassControl.className = errorClassControlCSS;
            }
        }
    }
}

function pushStyleClean(controlID, errorClassControlID)
{
    var control = document.getElementById(controlID);

    /*
     *  Apply clean state or original CSS if applicable
     */
    
    if(control != null)
    {
        if(ControlStyleCache[controlID] != null) control.className = ControlStyleCache[controlID];
        
        var errorClassControl = document.getElementById(errorClassControlID);
        
        if(errorClassControl != null)
        {
            if(ControlStyleCache[errorClassControlID] != null) errorClassControl.className = ControlStyleCache[errorClassControlID];
        }
    }
}

function newValidatorUpdateDisplay(val)
{
    oldValidatorUpdateDisplay(val);
    
    for (i = 0; i < Page_HighlightValidators.length; i++)
    {
        var validatorID = Page_HighlightValidators[i][0];
        var controlID = Page_HighlightValidators[i][1];
        var errorClassName = Page_HighlightValidators[i][2];
        var errorCallFunction = Page_HighlightValidators[i][3];
        
        var errorClassControlID = Page_HighlightValidators[i][4];        
        var errorClassControlCss = Page_HighlightValidators[i][5];
        
        if (val.id == validatorID && val.controltovalidate == controlID)
        {
            if (!val.isvalid)
                Stack_AddError(controlID, validatorID);
            else
                Stack_RemoveError(controlID, validatorID);
        }
        
        if(Stack_CheckError(controlID))
            pushStyleError(validatorID, controlID, errorClassName, errorClassControlID, errorClassControlCss);
        else
            pushStyleClean(controlID, errorClassControlID);
            
        /*
         *  Make sure results are accessable by the validator summary
         */
            
        if (typeof(Page_HighlightValidatorsSummaryByControl[controlID]) == "undefined")
        {
            Page_HighlightValidatorsSummaryByControl[controlID] = new Array();
        }
        
        Page_HighlightValidatorsSummaryByControl[controlID][validatorID] = val;
        
        
        /*
         * Execute any applied callback functions
         */
        
        if (errorCallFunction != "" && eval("typeof("+errorCallFunction+")") == "function")
        {
            if (!val.isvalid)
            {
                eval(errorCallFunction+"(val)");
            }
        }
    }
}

function trim(str)
{
    return str.replace(/^\s+|\s+$/, "");
}

window.onload = function()
{
    oldValidatorUpdateDisplay = ValidatorUpdateDisplay;
    ValidatorUpdateDisplay = newValidatorUpdateDisplay;
}